/**
* by H. Timucin OZdemir
*/

//** Necessary JAVA Classes
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;

//** Apperantly we need External Authoring Interface classes
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.field.*;
import vrml.external.exception.*;

public class 
CallBackExample extends Applet 
{  

   boolean           DEBUG             = true;

   Browser           browser           = null;
   Node              mugNode          = null;
   Node              draggerNode          = null;

   EventInSFVec3f    set_translation = null;
   EventOutSFVec3f   position_changed  = null;

   public void
   start()
   {

      /** Let's first get the handle of VRML 2.0 Browser */
      browser = (Browser) Browser.getBrowser(this);

      if(DEBUG==true) System.out.println("after browser handle ");
         
      try {
            if(DEBUG==true) System.out.println("before rootNode handle ");

            /** Get the Handle Of objects  */
            mugNode = browser.getNode("Mug");
            draggerNode = browser.getNode("Dragger");

            if(DEBUG==true) System.out.println("after rootNode handle ");
      
      } catch (InvalidNodeException e)
        { System.out.println("Invalid Node Exception"); }
      

      /** Get EventIns of the rootNode */
      set_translation = (EventInSFVec3f) mugNode.getEventIn("set_translation");

      position_changed = (EventOutSFVec3f) draggerNode.getEventOut("translation_changed");
      
      if(DEBUG == true ) System.out.println(" events are registered !! ");      

      /** Get EventIns of the viewer Node */
      applyFilter app = new applyFilter(set_translation,
                                        new Point3D(0.5f,-9.5f,-10f),
                                        new Point3D(9.5f,-0.5f,10f));

      position_changed.advise(app,null);


   }// end of start()

}// end of CallBackExample


class applyFilter implements EventOutObserver
{
   EventInSFVec3f  set_translation;
   Point3D         leftBottom;
   Point3D         rightTop;

   public 
   applyFilter( EventInSFVec3f _set_translation, Point3D _leftBottom, 
                Point3D _rightTop )
   {
      set_translation = _set_translation;
      adjust(_leftBottom,_rightTop);
   }// end of CONSTRUCTOR

   public void
   callback(EventOut value, double time, Object data)
   {
      float current[] = ((EventOutSFVec3f)value).getValue();
      System.out.println(" I am in callback() "); 
      System.out.println(" current[0] : "+current[0]); 
      System.out.println(" current[1] : "+current[1]); 
      System.out.println(" current[2] : "+current[2]); 

      if( current[0] >= leftBottom.x && current[0]<=rightTop.x &&
          current[1] >= leftBottom.y && current[1]<=rightTop.y &&
          current[2] >= leftBottom.z && current[2]<=rightTop.z )
      {
          float val[] = new float[3];
          //val[0] = current[0]; val[1] = 0.5f; val[2] = -1f*current[1];
          val[0] = current[0]; val[2] = -1f*current[1]; val[1] = 0.5f;
          if(set_translation!=null) set_translation.setValue(val);

      }// end of if
 
   }// end of callback()

   void
   adjust(Point3D _leftBottom, Point3D _rightTop)
   {
      float xmin = Math.min(_leftBottom.x,_rightTop.x);
      float xmax = Math.max(_leftBottom.x,_rightTop.x);

      float ymin = Math.min(_leftBottom.y,_rightTop.y);
      float ymax = Math.max(_leftBottom.y,_rightTop.y);

      float zmin = Math.min(_leftBottom.z,_rightTop.z);
      float zmax = Math.max(_leftBottom.z,_rightTop.z);

      leftBottom = new Point3D(xmin,ymin,zmin);
      rightTop = new Point3D(xmax,ymax,zmax);

   }// end of adjust()

}// end of applyFilter

class Point3D 
{ float x, y, z;
  public Point3D(float _x, float _y, float _z) { x=_x; y=_y; z=_z; } 
}
